
//[]{--------------------------------------------------------------------------------------------------------
//G.M.RC.BASiC   ϱ   Լ.
//G.M.RC.BASiC   ɾ Լ  ϰ ȣϿ Ҽ ְ Ѵ. 
//ڴ gmrcbasic.h  include Ͽ ϰ G.M.RC.BASiC  Լ Ҽ ִ. 
//
// Լ ̸ G.M.RC.BASiC-IDE    ɾ  ̸ ϰ տ "GMRCBASIC_"  ٿ
//Ͽϴ.  ϰ Ϳ ҽ Ϲ C   մϴ.
//
//2008.04.XX.X
//н ÷  
// ö
//}--------------------------------------------------------------------------------------------------------------


#include  "gmrcbasic-msg.h"
#include  "gmrcbasic.h"
#include  "..\uart\uart.h"


void GMRCBASIC_Ack(void)
{
  //<ACK>    Ѵ.
  // ͷƮ  ʰ  о óѴ.

  while(UART_Rxd() != d_ACK);

  return;

}

void GMRCBASIC_WaitReport(void)
{
  //Ϸȣ <END>    Ѵ.
  // ͷƮ  ʰ  о óѴ.

  while(UART_Rxd() != d_END);

  return;

}

void GMRCBASIC_MemSet(unsigned char  pDid)
{
  //[]{------------------------------------------
  //   /ӵ δ  ݿѴ.
  //
  //[]--------------------------------------- 
  //<2> + { <DID> + (MSG_MemSet) }
  //                               + <ACK>
  //}------------------------------------------------

  
  UART_Txd(2);
  UART_Txd(pDid);
  UART_Txd(d_MSG_MemSet);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_Degree(unsigned char  pDid, 
                      unsigned char  pSid,
					  unsigned char  pAccel,
					  unsigned char  pDegree)
{
  //[]{--------------------------------------------------------------
  // ϰ  ݿѴ.
  //
  //[]----------------------------------------------------------- 
  //<5> + { <DID> + (MSG_DegSet) + (SID) + (ӵ) + () }
  //                                                             + <ACK>
  //}--------------------------------------------------------------------
  
  UART_Txd(5);
  UART_Txd(pDid);
  UART_Txd(d_MSG_DegSet);
  UART_Txd(pSid);
  UART_Txd(pAccel);
  UART_Txd(pDegree);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_DegMem(unsigned char  pDid, 
                      unsigned char  pSid,
					  unsigned char  pAccel,
					  unsigned char  pDegree)
{
  //[]{--------------------------------------------------------------
  // ϵ ݿ ʴ´.
  //
  //[]----------------------------------------------------------- 
  //<5> + { <DID> + (MSG_DegMem) + (SID) + (ӵ) + () }
  //                                                             + <ACK>
  //}--------------------------------------------------------------------
  
  UART_Txd(5);
  UART_Txd(pDid);
  UART_Txd(d_MSG_DegMem);
  UART_Txd(pSid);
  UART_Txd(pAccel);
  UART_Txd(pDegree);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_DegMemX(unsigned char   pDid, 
                       unsigned char   pN,
					   unsigned char   pAccel,
					   unsigned char  *pDegree)
{
  //[]{--------------------------------------------------------------------------------------
  //[]   N(ִ 8) ÿ Ѵ.
  //
  //[]----------------------------------------------------------------------------------- 
  //<4 + N> + { <DID> + (MSG_DegMemX) + (N) + (ӵ) + (0) + ... + ((N-1)) }
  //                                                                                     + <ACK>
  // 1 <= N <= 8
  //}--------------------------------------------------------------------------------------------

  //[VAR]
  //{
      int  i;

  //}
  
  UART_Txd(4 + pN);
  UART_Txd(pDid);
  UART_Txd(d_MSG_DegMemX);
  UART_Txd(pN);
  UART_Txd(pAccel);

  for(i = 0; i < pN; i++)
  {
    UART_Txd(pDegree[i]);

  }

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}	

void GMRCBASIC_Speed(unsigned char  pDid, 
                     unsigned char  pSid,
					 unsigned char  pSpeed)
{
  //[]{-------------------------------------------------
  //ӵ ϰ  ݿѴ.
  //
  //[]----------------------------------------------
  //<4> + { <DID> + (MSG_SpdSet) + (SID) + (ӵ) }
  //                                                + <ACK>
  //}-------------------------------------------------------

  UART_Txd(4);
  UART_Txd(pDid);
  UART_Txd(d_MSG_SpdSet);
  UART_Txd(pSid);
  UART_Txd(pSpeed);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

} 

void GMRCBASIC_SpdMem(unsigned char  pDid, 
                      unsigned char  pSid,
					  unsigned char  pSpeed)
{
  //[]{-------------------------------------------------
  //ӵ ϳ ݿ ʴ´.
  //
  //[]----------------------------------------------
  //<4> + { <DID> + (MSG_SpdMem) + (SID) + (ӵ) }
  //                                                + <ACK>
  //}-------------------------------------------------------

  UART_Txd(4);
  UART_Txd(pDid);
  UART_Txd(d_MSG_SpdMem);
  UART_Txd(pSid);
  UART_Txd(pSpeed);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}    

void GMRCBASIC_SpdMemX(unsigned char   pDid, 
                       unsigned char   pN,
					   unsigned char  *pSpeed)
{
  //[]{-------------------------------------------------------------------------
  //[ӵ]   N(ִ 8) ÿ Ѵ.
  //
  //[]----------------------------------------------------------------------
  //<3 + N> + { <DID> + (MSG_SpdMemX) + (N) + (ӵ0) + ... + (ӵ(N-1)) }
  //                                                                        + <ACK>
  // 1 <= N <= 8
  //}-------------------------------------------------------------------------------

  //[VAR]
  //{
      int  i;

  //}
  
  UART_Txd(3 + pN);
  UART_Txd(pDid);
  UART_Txd(d_MSG_SpdMemX);
  UART_Txd(pN);

  for(i = 0; i < pN; i++)
  {
    UART_Txd(pSpeed[i]);

  }

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}	

void GMRCBASIC_DegSpd(unsigned char  pDid, 
                      unsigned char  pSid,
					  unsigned char  pAccel,
					  unsigned char  pDegree, 
			   		  unsigned char  pSpeed)
{
  //[]{--------------------------------------------------------------------------
  // ӵ ϰ  ݿѴ.
  //
  //[]-----------------------------------------------------------------------
  //<6> + { <DID> + (MSG_DegSpdSet) + (SID) + (ӵ) + () + (ӵ) }
  //                                                                         + <ACK>
  //}--------------------------------------------------------------------------------

  UART_Txd(6);
  UART_Txd(pDid);
  UART_Txd(d_MSG_DegSpdSet);
  UART_Txd(pSid);
  UART_Txd(pAccel);
  UART_Txd(pDegree);
  UART_Txd(pSpeed);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

} 

void GMRCBASIC_DegSpdMem(unsigned char  pDid, 
                         unsigned char  pSid,
						 unsigned char  pAccel,
						 unsigned char  pDegree, 
			   		     unsigned char  pSpeed)
{
  //[]{--------------------------------------------------------------------------
  // ӵ ϳ ݿ ʴ´.
  //
  //[]-----------------------------------------------------------------------
  //<6> + { <DID> + (MSG_DegSpdMem) + (SID) + (ӵ) + () + (ӵ) }
  //                                                                         + <ACK>
  //}--------------------------------------------------------------------------------

  UART_Txd(6);
  UART_Txd(pDid);
  UART_Txd(d_MSG_DegSpdMem);
  UART_Txd(pSid);
  UART_Txd(pAccel);
  UART_Txd(pDegree);
  UART_Txd(pSpeed);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_Pulse(unsigned char   pDid, 
                     unsigned char   pSid,
					 unsigned char   pAccel,
					 unsigned short  pTick)
{
  //[]{---------------------------------------------------------------------------
  // ̼ Ҷ ϰ 16bit  .
  //
  //[]------------------------------------------------------------------------
  //<6> + { <DID> + (MSG_TickSet) + (SID) + (ӵ) +(tick-h) + (tick-l) }
  //                                                                          + <ACK>
  //}---------------------------------------------------------------------------------

  UART_Txd(6);
  UART_Txd(pDid);
  UART_Txd(d_MSG_TickSet);
  UART_Txd(pSid);
  UART_Txd(pAccel);
  UART_Txd((pTick >> 8) & 0xff);
  UART_Txd(pTick & 0xff);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_Report(unsigned char   pDid)
{
  //[]{-----------------------------------------------
  // Ϸ  [ϷẸ]  Ұ Ѵ.
  //
  //[]--------------------------------------------
  //<2> + { <DID> + (MSG_Report) }
  //                               + <ACK>
  //}-----------------------------------------------------

  UART_Txd(2);
  UART_Txd(pDid);
  UART_Txd(d_MSG_Report);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_ReportTime(unsigned char   pDid,
                          unsigned char   pSid,
                          unsigned char   pReportTime)
{
  //[]{----------------------------------------------------------------
  //[ϷẸ]  Ѵ.
  //
  //[]-------------------------------------------------------------
  //<4> + { <DID> + (MSG_ReportTimeSet) + (SID) + (ϷẸ) }
  //                                                               + <ACK>
  //}----------------------------------------------------------------------

  UART_Txd(4);
  UART_Txd(pDid);
  UART_Txd(d_MSG_ReportTimeSet);
  UART_Txd(pSid);
  UART_Txd(pReportTime);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_ReportTimeX(unsigned char   pDid, 
                           unsigned char   pN,
					       unsigned char  *pReportTime)
{
  //[]{------------------------------------------------------------------------------------------------
  //[ϷẸ]  N(ִ 8) ÿ Ѵ.
  //
  //[]---------------------------------------------------------------------------------------------
  //<3 + N> + { <DID> + (MSG_ReportTimeSetX) + (N) + (ϷẸ0) + ... + (ϷẸ(N-1)) }
  //                                                                                               + <ACK>
  // 1 <= N <= 8
  //}------------------------------------------------------------------------------------------------------

  //[VAR]
  //{
      int  i;

  //}
  
  UART_Txd(3 + pN);
  UART_Txd(pDid);
  UART_Txd(d_MSG_ReportTimeSetX);
  UART_Txd(pN);

  for(i = 0; i < pN; i++)
  {
    UART_Txd(pReportTime[i]);

  }

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_AccelDiv(unsigned char   pDid,
                        unsigned char   pSid,
                        unsigned char   pDiv)
{
  //[]{--------------------------------------------------------
  //[   ]  Ѵ.
  //
  //[]-----------------------------------------------------
  //<4> + { <DID> + (MSG_AccelDivSet) + (SID) + (DIV ) }
  //                                                       + <ACK>
  //}--------------------------------------------------------------

  UART_Txd(4);
  UART_Txd(pDid);
  UART_Txd(d_MSG_AccelDivSet);
  UART_Txd(pSid);
  UART_Txd(pDiv);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_AccelDivX(unsigned char   pDid, 
                         unsigned char   pN,
					     unsigned char  *pDiv)
{
  //[]{----------------------------------------------------------------------------
  //[   ]  N(ִ 8) ÿ Ѵ.
  //
  //[]-------------------------------------------------------------------------
  //<3 + N> + { <DID> + (MSG_AccelDivSetX) + (N) + (DIV0) + ... + (DIV(N-1)) }
  //                                                                           + <ACK>
  // 1 <= N <= 8
  //}----------------------------------------------------------------------------------

  //[VAR]
  //{
      int  i;

  //}
  
  UART_Txd(3 + pN);
  UART_Txd(pDid);
  UART_Txd(d_MSG_AccelDivSetX);
  UART_Txd(pN);

  for(i = 0; i < pN; i++)
  {
    UART_Txd(pDiv[i]);

  }

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_PwmStart(unsigned char   pDid)
{
  //[]{----------------------------------------------------------------------------
  //pwm  ٽ Ѵ.
  //, eeprom  ݿ ʰ  ݿϸ, ڰ  eeprom 
  //pwm on/off  ٽ ݿ ִ ̴. (,    ٽ Ų.)
  //,  on   ͸ ٽ  Ǵ ̴.
  //
  //[]-------------------------------------------------------------------------
  //<2> + { <DID> + (MSG_PwmStart) }
  //                                 + <ACK>
  //}----------------------------------------------------------------------------------

  UART_Txd(2);
  UART_Txd(pDid);
  UART_Txd(d_MSG_PwmStart);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}

void GMRCBASIC_PwmStop(unsigned char   pDid)
{
  //[]{--------------------------------------
  //pwm  ߴѴ.
  //eeprom  ݿ ʰ  ݿѴ.
  //[]-----------------------------------
  //<2> + { <DID> + (MSG_PwmStop) }
  //                                + <ACK>
  //}--------------------------------------------

  UART_Txd(2);
  UART_Txd(pDid);
  UART_Txd(d_MSG_PwmStop);

  //<ACK> Ȯ.
  GMRCBASIC_Ack();

  return;

}



   

